--
-- MBtrac6570
-- Specialization for MBtrac6570 mod
--
-- @author  Stefan Geiger
-- @date  10/01/09
--
-- Copyright (C) GIANTS Software GmbH, Confidential, All Rights Reserved.

MBtrac6570 = {};

function MBtrac6570.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function MBtrac6570:load(xmlFile)

    hornSoundFile = Utils.getFilename("Sounds/horn.wav", self.baseDirectory);
    self.hornSoundId = createSample("famerCarSound");
    loadSample(self.hornSoundId, hornSoundFile, false);
    self.hornPlaying = false;
	
--[[Motorstart start]]--
    self.ignitionKey = false;
	self.allowedIgnition = false;                                                  
    self.motorStopSoundVolume2 = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorStopSound#volume"), 1.0);
--[[Motorstart ende]]--

--[[RMP Limiter start]]--
    local motorMaxRpmStr = getXMLString(xmlFile, "vehicle.motor#maxRpm");
    local motorMaxRpm1, motorMaxRpm2, motorMaxRpm3 = Utils.getVectorFromString(motorMaxRpmStr);
    motorMaxRpm1 = Utils.getNoNil(motorMaxRpm1, 800);
    motorMaxRpm2 = Utils.getNoNil(motorMaxRpm2, 1000);
    motorMaxRpm3 = Utils.getNoNil(motorMaxRpm3, 1800);
    local motorMaxRpm = {motorMaxRpm1, motorMaxRpm2, motorMaxRpm3};
    self.motorMaxRpmLimit = motorMaxRpm;
--[[RMP Limiter ende]]--
	
--[[Zwillingreifen start]]--
    self.twinWheel1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.twinWheel1#index"));
    self.twinWheel2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.twinWheel2#index"));
    self.twinWheel3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.twinWheel3#index"));
    self.twinWheel4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.twinWheel4#index"));	
--[[Zwillingreifen ende]]--	

--[[Bewegliche Heckkupplung start]]--
	local baseName = string.format("vehicle.trailerAttacherJoints.trailerAttacherJoint(%d)", 0);
	self.TAJindex = Utils.indexToObject(self.components, getXMLString(xmlFile, baseName.."#moveIndex"));
	if self.TAJindex ~= nil then
		self.TAJmoveMin = Utils.getNoNil(getXMLFloat(xmlFile, baseName.."#moveMin"),0);
		self.TAJmoveMax = Utils.getNoNil(getXMLFloat(xmlFile, baseName.."#moveMax"),0);
	end;
--[[Bewegliche Heckkupplung ende]]--

--[[Arbeitslicht Vorne start]]--
    self.numFrontlights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.frontlights#count"), 0);
    self.frontlights = {};
    for i=1, self.numFrontlights do
        local frontlightnamei = string.format("vehicle.frontlights.frontlight" .. "%d", i);
        self.frontlights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, frontlightnamei .. "#index"));
        setVisibility(self.frontlights[i], false);
    end;	
	self.frontlightsActive = false;	
--[[Arbeitslicht Vorne ende]]--

--[[Arbeitslicht Hinten start]]--
    self.numBacklights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.backlights#count"), 0);
    self.backlights = {};
    for i=1, self.numBacklights do
        local backlightnamei = string.format("vehicle.backlights.backlight" .. "%d", i);
        self.backlights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, backlightnamei .. "#index"));
        setVisibility(self.backlights[i], false);
    end;	
	self.backlightsActive = false;	
--[[Arbeitslicht Hinten ende]]--

--[[Bremse/Bremslicht start]]--
    self.brakeForce = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.brakeForce"), 10);
    self.motorBrakeForce = self.motor.brakeForce;
    local brakeSound = getXMLString(xmlFile, "vehicle.brakeSound#file");
    if brakeSound ~= nil and brakeSound ~= "" then
	  brakeSound = Utils.getFilename(brakeSound, self.baseDirectory); 
        self.brakeSound = createSample("brakeSound");
        loadSample(self.brakeSound, brakeSound, false);
        self.brakeSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.brakeSound#pitchOffset"), 0);
    end;
	self.extra_lights = {};
    self.lightsbrake = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.extra_lights.brake#index"));
    self.exhaustParticleLow = {};
    Utils.loadParticleSystem(xmlFile, self.exhaustParticleLow, "vehicle.exhaustParticleLow", self.rootNode, false, nil, self.baseDirectory);
    self.exhaustParticleHigh = {};
    Utils.loadParticleSystem(xmlFile, self.exhaustParticleHigh, "vehicle.exhaustParticleHigh", self.rootNode, false, nil, self.baseDirectory);
    self.brakeOn = false;
    self.revLimit = 100;
    self.maxRpm3 = self.motor.maxRpm[3];	
--[[Bremse/Bremslicht ende]]--

--[[Blinker start]]--
	turn1SoundFile = Utils.getFilename("Sounds/turn1.wav", self.baseDirectory);
    self.turn1 = createSample("turn1");
    loadSample(self.turn1, turn1SoundFile, false);
	turn2SoundFile = Utils.getFilename("Sounds/turn2.wav", self.baseDirectory);
    self.turn2 = createSample("turn2");
    loadSample(self.turn2, turn2SoundFile, false);	
	
    self.numTurnlights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.turnlights#count"), 0);
    self.turnlights = {};
    for i=1, self.numTurnlights do
        local turnlightnamei = string.format("vehicle.turnlights.turnlight" .. "%d", i);
        self.turnlights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, turnlightnamei .. "#index"));
        setVisibility(self.turnlights[i], false);
    end;	
	self.turnlightsActive = false;
	
    self.numTurnlights2 = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.turnlights2#count"), 0);
    self.turnlights2 = {};
    for i=1, self.numTurnlights2 do
        local turnlightnamei2 = string.format("vehicle.turnlights2.turnlight" .. "%d", i);
        self.turnlights2[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, turnlightnamei2 .. "#index"));
        setVisibility(self.turnlights2[i], false);
    end;	
	self.turnlightsActive2 = false;	
--[[Blinker ende]]--

--[[fr Tasten, die in der Modxml festgelegt werden]]--
    self.keys = {};
    local i=0;
    while true do
        local baseName = string.format("vehicle.keys.input(%d)", i);
        local inputName = getXMLString(xmlFile, baseName.. "#name");
        if inputName == nil then
            break;
        end;
        local inputKey = getXMLString(xmlFile, baseName.. "#key");
        if Input[inputKey] == nil then
            print("Error: invalid key '" .. inputKey .. "'  for input event '" .. inputName .. "'");
            break;
        end;
        self.keys[inputName] = Input[inputKey];
        i = i+1;
    end;

--[[Tastenbelegung und Textausgabe wird in modDesc festgelegt]]--	
	self.keyType = InputBinding.getButtonKeyName;
	self.keyName = " ";	
end;

function MBtrac6570:delete()
    delete(self.hornSoundId);
end;

function MBtrac6570:mouseEvent(posX, posY, isDown, isUp, button)
end;

function MBtrac6570:keyEvent(unicode, sym, modifier, isDown)

--[[Zwillingsbereifung start]]--	
	if InputBinding.isPressed(InputBinding.MBtrac6570_TWINS) then 
		self.dualwheels = not self.dualwheels;
		setVisibility(self.twinWheel1, self.dualwheels);
		setVisibility(self.twinWheel2, self.dualwheels);
		setVisibility(self.twinWheel3, self.dualwheels);
		setVisibility(self.twinWheel4, self.dualwheels);	
	end;
--[[Zwillingsbereifung ende]]--

--[[Arbeitslicht start]]--
	if InputBinding.isPressed(InputBinding.MBtrac6570_FRONTLIGHT) then	
		self.frontlightsActive = not self.frontlightsActive;
		self.farlightsActive = false;
		self.backlightsActive = false;
	end;

	if InputBinding.isPressed(InputBinding.MBtrac6570_REARLIGHT) then	
		self.backlightsActive = not self.backlightsActive;
		self.farlightsActive = false;		
		self.frontlightsActive = false;		
	end;
--[[Arbeitslicht/Rckfahrlicht ende]]--

--[[Blinker start]]--
--[[Blinker Rechts]]--
	if InputBinding.isPressed(InputBinding.MBtrac6570_TURNRIGHTLIGHT) then
		self.flashLeft = not self.flashLeft;
		self.delayOnLeft = 10;
		self.flashRight = false;
		self.flash = false;
		self.flashlightsRightActive = false;
		self.flashlightsWarnerActive = false;
		self.flashlightsRight2Active = false;
		self.turnlightsActive2 = false;
		self.flashWarner = false;
	end;
--[[Warnblinker]]--
	if InputBinding.isPressed(InputBinding.MBtrac6570_WARNLIGHT) then
		self.flash = not self.flash;
		self.flashRight = false;
		self.flashLeft = false;
		self.delayOn = 20;
		self.flashlightsRightActive = false;
		self.flashlightsLeftActive = false;
		self.flashWarner = not self.flashWarner;
	end;
--[[Blinker Links]]--
	if InputBinding.isPressed(InputBinding.MBtrac6570_TURNLEFTLIGHT) then
		self.flashRight = not self.flashRight;
		self.delayOnRight = 10;
		self.flashLeft = false;
		self.flash = false;
		self.flashlightsLeftActive = false;
		self.flashlightsWarnerActive = false;
		self.flashlightsLeft2Active = false;
		self.turnlightsActive = false;
		self.flashWarner = false;
	end;
--[[Blinker ende]]--

    if InputBinding.isPressed(InputBinding.MBtrac6570_HELP) then
		self.helpPanel = not self.helpPanel;
	end;
	
--[[Hilfeanzeige start]]--
    if InputBinding.isPressed(InputBinding.MBtrac6570_LIGHTHELP) then
		self.lighthelpPanel = not self.lighthelpPanel;
	end;	
end;

function MBtrac6570:update(dt)
    if self:getIsActiveForInput() and self:getIsActiveForSound() and InputBinding.isPressed(InputBinding.MBtrac6570_HUPE) then
        if not self.hornPlaying then
            playSample(self.hornSoundId, 0, 1, 0);
            self.hornPlaying = true;
        end;
    else
        if self.hornPlaying then
            stopSample(self.hornSoundId);
            self.hornPlaying = false;
        end;
    end;
	
--[[Motorstart start]]--
    if not self.isAITractorActivated then
        if self:getIsActiveForInput() then
            if InputBinding.hasEvent(InputBinding.MBtrac6570_IGNITION) then
		        self.ignitionKey = not self.ignitionKey;
			    self.allowedIgnition = true;
	        end;
	    end;
	    if not self.allowedIgnition and  not self.ignitionKey then
            self.isMotorStarted = false;
            Motorized.stopSounds(self);
	        self.steeringEnabled = false;
            Utils.setEmittingState(self.exhaustParticleSystems, false)
	    end;
	    if not self.ignitionKey then
	        self.motorStopSoundVolume = 0;
        else
	        self.motorStopSoundVolume = self.motorStopSoundVolume2;
	    end;
	    if self.allowedIgnition then
	        if  not self.ignitionKey then
		        self.motorStopSoundVolume = self.motorStopSoundVolume2;
                self:stopMotor();
			    self.steeringEnabled = false;
                self.allowedIgnition = false;	
                for k,wheel in pairs(self.wheels) do
                    setWheelShapeProps(wheel.node, wheel.wheelShape, 0, self.motor.brakeForce, 0);
                end;
                self:onDeactivateAttachements();
	        elseif self.ignitionKey then
                self:startMotor();
                self.steeringEnabled = true;
                self.allowedIgnition = false;		
       	    end;
	    end;
    elseif not self.ignitionKey and not self.deactivateOnLeave then
		self:stopAITractor();
	end;
--[[Motorstart ende]]--	

--[[RMP Limiter start]]--
    if self.isMotorStarted and self:getIsActiveForInput() and self.isEntered then
	    if self.motor.speedLevel ~= 0 then
            if InputBinding.isPressed(InputBinding.MBtrac6570_ACCELERATE) then
		        if self.motor.maxRpm[self.motor.speedLevel] <= (self.motorMaxRpmLimit[3] - 10) then
		            self.motor.maxRpm[self.motor.speedLevel] = self.motor.maxRpm[self.motor.speedLevel] + 10;
			    end;
		    elseif InputBinding.isPressed(InputBinding.MBtrac6570_DECELERATE) then
		        if self.motor.maxRpm[self.motor.speedLevel] >= 10 then
			        self.motor.maxRpm[self.motor.speedLevel] = self.motor.maxRpm[self.motor.speedLevel] - 10;
			    end;
	    	end;
		else
            if InputBinding.isPressed(InputBinding.MBtrac6570_ACCELERATE) then
		        if self.motor.maxRpm[3] <= (self.motorMaxRpmLimit[3] - 10) then
		            self.motor.maxRpm[3] = self.motor.maxRpm[3] + 10;
			    end;
		    elseif InputBinding.isPressed(InputBinding.MBtrac6570_DECELERATE) then
		        if self.motor.maxRpm[3] >= 10 then
			            self.motor.maxRpm[3] = self.motor.maxRpm[3] - 10;
			    end;
	    	end;
	    end;
	end;
--[[RMP Limiter ende]]--

--[[Gaslimiter start]]--
    if self:getIsActiveForInput() then
        if InputBinding.isPressed(InputBinding.MBtrac6570_MORERPM) then
		    self.motor.minRpm = self.motor.minRpm - 100;
		elseif InputBinding.isPressed(InputBinding.MBtrac6570_LESSRPM) then
		    self.motor.minRpm = self.motor.minRpm + 100;
	    end;
    end;

    if self.isEntered then
		if self.motor.minRpm < -1600 then
			self.motor.minRpm = -1600;
		elseif self.motor.minRpm > 200 then
			self.motor.minRpm = 200;
		end;
	end;
--[[Gaslimiter ende]]--

--[[Bremse/Bremslicht start]]--
    if self.isEntered then
        self.motor.maxRpm[3] = string.format("%d",(self.revLimit * self.maxRpm3 / 100));
        local brake = false;
        if self.motor.brakeForce == self.brakeForce and getInputAxis(Input.AXIS_Y) ~= 0 then
          brake = true;
          self.motor.maxRpm[3] = 0;
        end;
        if (self.movingDirection*self.lastSpeed*(-getInputAxis(Input.AXIS_Y))) < -0.001 then
           brake = true;
           self.brakeOn = true;
           self.motor.brakeForce = self.brakeForce;
        elseif not brake then
           self.motor.brakeForce = self.motorBrakeForce;
        end;
        setVisibility(self.lightsbrake, brake);
        if self.brakeOn and not brake then
            if self.brakeSound ~= nil then
                setSamplePitch(self.brakeSound, self.brakeSoundPitchOffset);
                playSample(self.brakeSound, 1, 1, 0);
            end;
            self.brakeOn = false;
        end;
        if getInputAxis(Input.AXIS_Y) ~= 0 and not brake then
        	Utils.setEmittingState(self.exhaustParticleLow, false);
        	Utils.setEmittingState(self.exhaustParticleHigh, true);
        else
        	Utils.setEmittingState(self.exhaustParticleLow, false);
        	Utils.setEmittingState(self.exhaustParticleHigh, false);
        end;
	end;
--[[Bremse/Bremslicht ende]]--

--[[Bewegliche Heckkupplung start]]--
		self.jointmove = false;		
		local x,y,z = getTranslation(self.TAJindex);		
		if InputBinding.isPressed(InputBinding.MBtrac6570_MOVEUP) and y < self.TAJmoveMax then
			y = y + 0.01;
			self.jointmove = true;	
        elseif InputBinding.isPressed(InputBinding.MBtrac6570_MOVEDOWN) and y > self.TAJmoveMin then
			y = y - 0.01;
			self.jointmove = true;	
        end;
		setTranslation(self.TAJindex, x,y,z);	
--[[Bewegliche Heckkupplung ende]]--

--[[Arbeitslicht Vorne start]]----------------------------------------
	   if self.frontlightsActive then
			for i=1, self.numFrontlights do
				local frontlight = self.frontlights[i];
				setVisibility(frontlight, self.frontlightsActive);
			end;
		else
			for i=1, self.numFrontlights do
				local frontlight = self.frontlights[i];
				setVisibility(frontlight, self.frontlightsActive, false);
			end;
		end;	
--[[Arbeitslicht Vorne ende]]------------------------------------------

--[[Arbeitslicht start]]----------------------------------------
	if not self.reverselightsActive then
		if self.movingDirection < 0 then
			self.reverselightsActive = true;
		else
			self.reverselightsActive = false;
		end;
	end;

	   if self.backlightsActive then
			for i=1, self.numBacklights do
				local backlight = self.backlights[i];
				setVisibility(backlight, self.backlightsActive);
			end;
		else
			for i=1, self.numBacklights do
				local backlight = self.backlights[i];
				setVisibility(backlight, self.backlightsActive, false);
			end;
		end;	
--[[Arbeitslicht ende]]--

--[[AI Nightlight start]]--
	if g_currentMission.environment ~= nil and g_currentMission.environment.dayNightCycle and
        (g_currentMission.environment.dayTime > (20.5*1000*60*60) or g_currentMission.environment.dayTime < (5.5*1000*60*60)) and
        not self.lightsActive and self.isHired and not self.steeringEnabled then
		self.lightsActive = true;
	end;
	if not self.isHired and self.lightsActive and not self.isEntered or not g_currentMission.environment.dayNightCycle then
		self.lightsActive = false;
	end;
    for k, light in pairs(self.lights) do
        setVisibility(light, self.lightsActive);
    end;	
--[[AI Nightlight ende]]--

--[[Blinker start]]--
	if self.flash then
		if self.delayOn >= 0 then
			self.delayOn = self.delayOn -dt;
		end;
		if not self.flashlightsRightActive then
			if self.delayOn < 0 then
				self.delayOff = 500;
				self.flashlightsRightActive = true;
				self.flashlightsLeftActive = true;
				self.flashlightsWarnerActive = true;
				self.turnlightsActive2 = true;
				self.turnlightsActive = true;
				playSample(self.turn1, 1, 0.7, 0);
			end;
		end;
		if self.delayOff >= 0 then
			self.delayOff = self.delayOff -dt;
		end;
		if self.flashlightsRightActive then
			if self.delayOff < 0 then
				self.delayOn = 500;
				self.flashlightsLeftActive = false;
				self.flashlightsRightActive = false;
				self.flashlightsWarnerActive = false;
				self.turnlightsActive2 = false;
				self.turnlightsActive = false;
				playSample(self.turn2, 1, 0.7, 0);
			end;
		end;
	end;
	
	if self.flashRight then
		if self.delayOnRight >= 0 then
			self.delayOnRight = self.delayOnRight -dt;
		end;
		if not self.flashlightsRightActive then
			if self.delayOnRight < 0 then
				self.delayOffRight = 500;
				self.flashlightsRightActive = true;
				self.turnlightsActive2 = true;
				playSample(self.turn1,1,0.7,0);
			end;
		end;
		if self.delayOffRight >= 0 then
			self.delayOffRight = self.delayOffRight -dt;
		end;
		if self.flashlightsRightActive then
			if self.delayOffRight < 0 then
				self.delayOnRight = 500;
				self.flashlightsRightActive = false;
				self.turnlightsActive2 = false;
				playSample(self.turn2,1,0.7,0);
			end;
		end;
	else
		if not self.flashWarner then
			self.turnlightsActive2 = false;
		end;
	end;
	
		if self.flashLeft then
			if self.delayOnLeft >= -1 then
				self.delayOnLeft = self.delayOnLeft -dt;
			end;
			if not self.flashlightsLeftActive then
				if self.delayOnLeft < 0 then
					self.delayOffLeft = 500;
					self.flashlightsLeftActive = true;
					self.turnlightsActive = true;
					playSample(self.turn1,1,0.7,0);
				end;
			end;
			if self.delayOffLeft >= 0 then
				self.delayOffLeft = self.delayOffLeft -dt;
			end;
			if self.flashlightsLeftActive then
				if self.delayOffLeft < 0 then
					self.delayOnLeft = 500;
					self.flashlightsLeftActive = false;
					self.turnlightsActive = false;
					playSample(self.turn2,1,0.7,0);
				end;
			end;
		else
			if not self.flashWarner then
				self.turnlightsActive = false;
			end;
		end;
		
		if self.turnlightsActive then
			for i=1, self.numTurnlights do
				local turnlight = self.turnlights[i];
				setVisibility(turnlight, self.turnlightsActive);
			end;
		else
			for i=1, self.numTurnlights do
				local turnlight = self.turnlights[i];
				setVisibility(turnlight, self.turnlightsActive, false);
			end;
		end;
    	if self.turnlightsActive2 then
			for i=1, self.numTurnlights2 do
				local turnlight2 = self.turnlights2[i];
				setVisibility(turnlight2, self.turnlightsActive2);
			end;
		else
			for i=1, self.numTurnlights2 do
				local turnlight2 = self.turnlights2[i];
				setVisibility(turnlight2, self.turnlightsActive2, false);
			end;
		end;	
--[[Blinker ende]]--
end;

function MBtrac6570:draw()
    if self.isMotorStarted then
		if self.motor.speedLevel ~= 0 then
			g_currentMission:addExtraPrintText("Taste NUM +/-:   "..string.format("%d RPM",self.motor.maxRpm[self.motor.speedLevel]).."");
		else
			g_currentMission:addExtraPrintText("Taste NUM +/-:   "..string.format("%d RPM",self.motor.maxRpm[3]).."");
		end;
	end;
    if self.isMotorStarted then	
		g_currentMission:addExtraPrintText(string.format("Taste %s/%s: %s", InputBinding.getButtonKeyName(InputBinding.MBtrac6570_MORERPM), InputBinding.getButtonKeyName(InputBinding.MBtrac6570_LESSRPM), g_i18n:getText("MBtrac6570_Gas")));
    end;	
	
    if self.isEntered then
		setTextBold(true);
		if not self.isMotorStarted and not self.automaticStart then
			renderText(0.8, 0.17, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBtrac6570_IGNITION).. ": " ..g_i18n:getText("MBtrac6570_Start"));		
		end;	
		if self.isMotorStarted then
			if not self.helpPanel then
				renderText(0.8335, 0.15, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBtrac6570_HELP).. ": " ..g_i18n:getText("MBtrac6570_Info1"));
			else
				renderText(0.8335, 0.15, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBtrac6570_HELP).. ": " ..g_i18n:getText("MBtrac6570_Info2"));
			end;			
			if self.helpPanel then
				renderText(0.72, 0.89, 0.025, "- Fendt 936 Info -");
				renderText(0.72, 0.875, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBtrac6570_HUPE).. ": " ..g_i18n:getText("MBtrac6570_HORN"));	
				renderText(0.72, 0.86, 0.02, "  Bildauf: Kupplung Heben");--[[Feste Tastenbelegung]]--
				renderText(0.72, 0.845, 0.02, "  Bildab: Kupplung Senken");--[[Feste Tastenbelegung]]--	
				if self.dualwheels then
					renderText(0.72, 0.8, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBtrac6570_TWINS).. ": " ..g_i18n:getText("MBtrac6570_Twins1"));					
				else
					renderText(0.72, 0.8, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBtrac6570_TWINS).. ": " ..g_i18n:getText("MBtrac6570_Twins2"));				
				end;				
			end;
		end;
	
		if self.isMotorStarted then		
			if not self.lighthelpPanel then
				renderText(0.8, 0.17, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBtrac6570_LIGHTHELP).. ": " ..g_i18n:getText("MBtrac6570_LichtInfo1"));
			else
				renderText(0.8, 0.17, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBtrac6570_LIGHTHELP).. ": " ..g_i18n:getText("MBtrac6570_LichtInfo2"));
			end;
			if self.lighthelpPanel then
				renderText(0.72, 0.77, 0.025, "- LichtInfo -");
				if self.frontlightsActive then
					renderText(0.72, 0.755, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBtrac6570_FRONTLIGHT).. ": " ..g_i18n:getText("MBtrac6570_Arbeitslicht1")); 
				else
					renderText(0.72, 0.755, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBtrac6570_FRONTLIGHT).. ": " ..g_i18n:getText("MBtrac6570_Arbeitslicht2"));
				end;			
				if self.backlightsActive then
					renderText(0.72, 0.725, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBtrac6570_REARLIGHT).. ": " ..g_i18n:getText("MBtrac6570_Arbeitslicht3"));				
				else
					renderText(0.72, 0.725, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBtrac6570_REARLIGHT).. ": " ..g_i18n:getText("MBtrac6570_Arbeitslicht4"));				
				end;
				if not self.flashLeft then
					renderText(0.72, 0.695, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBtrac6570_TURNRIGHTLIGHT).. ": " ..g_i18n:getText("MBtrac6570_Blinkerrechts1")); 
				elseif self.flashLeft then
					renderText(0.72, 0.695, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBtrac6570_TURNRIGHTLIGHT).. ": " ..g_i18n:getText("MBtrac6570_Blinkerrechts2"));
				end;
				if not self.flash then
					renderText(0.72, 0.68, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBtrac6570_WARNLIGHT).. ": " ..g_i18n:getText("MBtrac6570_Warnblinker1")); 
				elseif self.flash then
					renderText(0.72, 0.68, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBtrac6570_WARNLIGHT).. ": " ..g_i18n:getText("MBtrac6570_Warnblinker2"));
				end;
				if not self.flashRight then
					renderText(0.72, 0.665, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBtrac6570_TURNLEFTLIGHT).. ": " ..g_i18n:getText("MBtrac6570_Blinkerlinks1")); 
				elseif self.flashRight then
					renderText(0.72, 0.665, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBtrac6570_TURNLEFTLIGHT).. ": " ..g_i18n:getText("MBtrac6570_Blinkerlinks2"));
				end;
			end;		
		end;
	setTextBold(false);		
	end;
end;

--[[Gaslimiter start]]--
function MBtrac6570:stopMotor()
    self.motor.minRpm = 200;
end;
--[[Gaslimiter ende]]--

function MBtrac6570:onEnter()
    Utils.setEmittingState(self.exhaustParticleLow, false);
end;

function MBtrac6570:onLeave()
	if not self.deactivateOnLeave then
	    self.allowedIgnition = false;
	    self.ignitionKey = true; 
    else
	    self.allowedIgnition = false;
	    self.ignitionKey = false;
	end;
    self.frontlightsActive = false;
    self.backlightsActive = false;
    Utils.setEmittingState(self.exhaustParticleLow, false);	
	self.weightActive = false;	
end;

function MBtrac6570:validateAttacherJoint(implement, jointDesc, dt)
	if self.jointmove then
		return true;
	end;
end;

--[[Tasten werden hier im Script festgelegt / Unter der "draw"-funktion Textausgabe eintragen]]--
function key_convert(key)
    if key ~= nil then 
	    local keyname = "";
	    if key > 32 and key < 123 then
	    	keyname = string.upper(string.char(key));
	    elseif key > 255 and key < 266 then
	    	keyname = "NUM "..string.char(key-208);
	    else 
	    	keyname = "";
	    end;
	    return(keyname);
	end;
end;